﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace TCP_Print
{
    public partial class Form1 : Form
    {
        delegate void ProcessSocketConnected();
        ProcessSocketConnected _processconnected;
        delegate void ProcessSocketDisconnected();
        ProcessSocketDisconnected _processdisconnected;
        delegate void ProcessSocketRecived(String data);
        ProcessSocketRecived _processreceived;

        String ip_adress;
        int port;
        TCPIP_Comm lan_comm = new TCPIP_Comm();

        public Form1()
        {
            InitializeComponent();
        }

        private void ProcessConnectedCommand()
        {
            //Client와 연결되었을때 이벤트 처리(디스플레이용)
            ConnectList.Items.Add(cTCP_Address.Text + "와 연결되었음!!!");  //Client과 연결이 되었으면 Client쪽 IP주소를 Display함
            ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
        }

        private void Client_Connected()
        {
            //Client와 연결되었을때 이벤트 처리(원래의 이벤트)
            object[] args = {};
            Invoke(_processconnected, args); //디스플레이용을 실행
        }
        
        private void ProcessDisconnectedCommand()
        {
            // Client와의 연결이 끊어졌을때 이벤트 처리(디스플레이용)
            ConnectList.Items.Add("연결 끊겼음!!!!"); 
            ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
        }

        private void Client_Disconnected()
        {
            // Client와의 연결이 끊어졌을때 이벤트 처리(원래의 이벤트)
            object[] args = {};
            Invoke(_processdisconnected, args); //디스플레이용을 실행
        }
        
        private void ProcessReceivedCommand(String data)
        {
            ConnectList.Items.Add(data);
            ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
        }

        private void Client_Received(String data)
        {
            //상대방 TCP에서 받은 데이타를 처리(원래의 이벤트)
            object[] args = { data };
            Invoke(_processreceived, args);  //디스플레이용 실행

        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (lan_comm.IsConnected == true)
            {
                lan_comm.Disconnect();
            }
            Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ConnectList.Items.Clear();
        }

        private void buttonSeverStart_Click(object sender, EventArgs e)
        {
            ip_adress = cTCP_Address.Text;
            port = int.Parse(cPortNum.Text);
            if (lan_comm.Connect(ip_adress, port) == 0)
            {
                ConnectList.Items.Add("연결되지 않았습니다.");
                ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
            }

        }

        private void buttonServerStop_Click(object sender, EventArgs e)
        {
            if (lan_comm.IsConnected == true)
            {
                lan_comm.Disconnect();
                ConnectList.Items.Add("연결 끊겼음!!!!");
                ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
            }
            else
            {
                ConnectList.Items.Add("연결되어 있지 않습니다.");
                ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (lan_comm.IsConnected == true)
            {
                lan_comm.WriteTCPASCII("{WS|}");
            }
            else
            {
                ConnectList.Items.Add("연결되어 있지 않습니다.");
                ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ConnectList.Items.Clear();
            _processconnected = new ProcessSocketConnected(ProcessConnectedCommand);
            lan_comm.connected += new SocketConnected(Client_Connected);
            _processdisconnected = new ProcessSocketDisconnected(ProcessDisconnectedCommand);
            lan_comm.disconnected += new SocketDisconnected(Client_Disconnected);
            _processreceived = new ProcessSocketRecived(ProcessReceivedCommand);
            lan_comm.received += new SocketReived(Client_Received);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int print_count = 1; //인쇄수량

            if (lan_comm.IsConnected == true)
            {
                lan_comm.WriteTCPASCII("{D0330,1000,0300|}");
                lan_comm.WriteTCPASCII("{C|}");
                lan_comm.WriteTCPASCII("{PC001;0100,0100,1,1,A,00,B|}");
                lan_comm.WriteTCPASCII("{RC001;ABCD|}");
                lan_comm.WriteTCPASCII("{PC002;0100,0150,1,1,51,00,B|}");
                lan_comm.WriteTCPASCII("{RC002;" + lan_comm.GetHangul("가나다123ABC DEF") + "|}");
                lan_comm.WriteTCPASCII("{XS;I," + String.Format("{0:0000}", print_count) + ",0000C5001|}");
            }
            else
            {
                ConnectList.Items.Add("연결되어 있지 않습니다.");
                ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            int print_count = 1; //인쇄수량

            if (lan_comm.IsConnected == true)
            {
                lan_comm.WriteTCPUTF8("{D0330,1000,0300|}");
                lan_comm.WriteTCPUTF8("{C|}");
                lan_comm.WriteTCPUTF8("{PC001;0100,0100,1,1,A,00,B|}");
                lan_comm.WriteTCPUTF8("{RC001;ABCD|}");
                lan_comm.WriteTCPUTF8("{PV01;0100,0150,0040,0040,01,0,00,B|}");
                lan_comm.WriteTCPUTF8("{RV01;가나다123abcDEF (주)티비에스|}");
                lan_comm.WriteTCPUTF8("{XS;I," + String.Format("{0:0000}", print_count) + ",0000C5001|}");
            }
            else
            {
                ConnectList.Items.Add("연결되어 있지 않습니다.");
                ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            int print_count = 1; //인쇄수량

            if (lan_comm.IsConnected == true)
            {
                lan_comm.WriteTCPASCII("{D0330,1000,0300|}");
                lan_comm.WriteTCPASCII("{C|}");
                lan_comm.WriteTCPASCII("{PC001;0010,0030,1,1,A,00,B|}");
                lan_comm.WriteTCPASCII("{RC001;ABCD|}");
                lan_comm.WriteTCPASCII("{PC000;0010,0050,1,1,s,00,B|}");
                lan_comm.WriteTCPASCII("{RC002;AB12 3 가각간\\KO%$#@!*(&()_,.￦|}");  //주의: \ 전송시는 \\로 보내야 함.
                lan_comm.WriteTCPASCII("{XS;I," + String.Format("{0:0000}", print_count) + ",0000C1011|}");
            }
            else
            {
                ConnectList.Items.Add("연결되어 있지 않습니다.");
                ConnectList.SelectedIndex = ConnectList.Items.Count - 1;
            }
        }


    }
}