using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Threading;
using System.IO;
using System.Net;
using System.Windows.Forms;
using System.Drawing;
using System.Text.RegularExpressions;

namespace TCP_Print
{
    delegate void SocketConnected();
    delegate void SocketDisconnected();
    delegate void SocketReived(String data);
    
    class TCPIP_Comm
    {
        private bool _connected = false;
        public const int READ_BUFFER_SIZE = 255;

        public event SocketConnected connected;
        public event SocketDisconnected disconnected;
        public event SocketReived received;

        Thread reader;

        private TcpClient _client;
        private NetworkStream _stream;
        private bool _waitstop = false;

        public bool IsConnected
        {
            get
            {
               // return _connected;
                try
                {
                    if (_connected == true)
                    {
                        bool ret = !(_client.Client.Poll(1, SelectMode.SelectRead) && _client.Available == 0);
                        if (!ret)
                        {
                            Disconnect();
                        }
                        return ret;
                    }
                    else
                    {
                        return false;
                    }
                }
                catch (SocketException) { return false; }
            }
        }

        public bool WaitStop
        {
            get
            {
                return _waitstop;
            }
            set
            {
                _waitstop = value;
            }

        }

        public int Disconnect()  // ִ Լ
        {
            if (_client == null) return 0;
            try
            {
                if (_connected == true)
                {
                    reader.Abort();
                    _stream.Close();
                    _client.Close();
                    _connected = false;
                    return 1;
                }
                else return 0;
            }
            catch
            {
                return 0;
            }

        }



        public int Connect(string address, int port)   // ϴ Լ
        {
            int close_check = Disconnect();
            IPAddress SeverIP = IPAddress.Parse("127.0.0.1");
            try
            {
                SeverIP = IPAddress.Parse(address);
            }
            catch
            {
                return 0;
            }
            IPEndPoint endPoint = new IPEndPoint(SeverIP, port);
            _client = new TcpClient();

            try
            {
                _client.Connect(new IPEndPoint(SeverIP, port));
            }
            catch
            {
                Disconnect();
                return 0;
            }
            int size = sizeof(UInt32);
            UInt32 on = 1;
            UInt32 keepAliveInterval = 1000;   // Send a packet once every 10 seconds.
            UInt32 retryInterval = 1000;        // If no response, resend every second.
            byte[] inArray = new byte[size * 3];
            Array.Copy(BitConverter.GetBytes(on), 0, inArray, 0, size);
            Array.Copy(BitConverter.GetBytes(keepAliveInterval), 0, inArray, size, size);
            Array.Copy(BitConverter.GetBytes(retryInterval), 0, inArray, size * 2, size);

            _client.Client.IOControl(IOControlCode.KeepAliveValues, inArray, null);
            
            connected();
            reader = new Thread(new ThreadStart(Recieve));  //͸  óϴ Լ Thread 
            reader.Start();
            _connected = true;
            _stream = _client.GetStream();
            _waitstop = true;
            return 1;

        }

        //  ƴ üũϴ Լ
        public bool IsNumber(String strNumber)
        {
            Regex objNotNumberPattern = new Regex("[^0-9.-]");
            Regex objTwoDotPattern = new Regex("[0-9]*[.][0-9]*[.][0-9]*");
            Regex objTwoMinusPattern = new Regex("[0-9]*[-][0-9]*[-][0-9]*");
            String strValidRealPattern = "^([-]|[.]|[-.]|[0-9])[0-9]*[.]*[0-9]+$";
            String strValidIntegerPattern = "^([-]|[0-9])[0-9]*$";
            Regex objNumberPattern = new Regex("(" + strValidRealPattern + ")|(" + strValidIntegerPattern + ")");
            return !objNotNumberPattern.IsMatch(strNumber) && !objTwoDotPattern.IsMatch(strNumber) &&
                  !objTwoMinusPattern.IsMatch(strNumber) && objNumberPattern.IsMatch(strNumber);
        }

        private String GetStatus(String data)
        {
            String result = " ߸!";
            String tt = data;
            try
            {
                if (IsNumber(tt))
                {
                    int stat = int.Parse(tt);
                    switch (stat)
                    {
                        case 0: result = "!"; break;
                        case 1: result = "忭!"; break;
                        case 2: result = "..."; break;
                        case 3: result = "..."; break;
                        case 4: result = ""; break;
                        case 5: result = "Ʈ  "; break;
                        case 6: result = "ɿ"; break;
                        case 7: result = "ſ"; break;
                        case 11: result = "ɸ!"; break;
                        case 12: result = "ĿͿ!"; break;
                        case 13: result = "!"; break;
                        case 14: result = "!"; break;
                        case 15: result = "忭!"; break;
                        case 17: result = "忡!"; break;
                        case 18: result = "̻!"; break;
                        case 21: result = "!"; break;
                        case 22: result = "δ Ǯ!"; break;
                        case 27: result = "!"; break;
                        case 28: result = ""; break;
                        case 29: result = "!"; break;
                        case 32: result = " ͸ µ"; break;
                        case 33: result = "͸ ʰ µ"; break;
                        case 36: result = "͸ 뷮 "; break;
                        case 37: result = ""; break;
                        case 40: result = "Ϸ"; break;
                        case 41: result = "ǵϷ"; break;
                        case 45: result = "͸  "; break;
                        case 46: result = " µ  "; break;
                        case 47: result = " µ  "; break;
                        case 50: result = "÷޸ ٿε忡"; break;
                        case 51: result = "÷޸ ˿"; break;
                        case 54: result = "÷޷θ 뷮"; break;
                        default: result = "¾˼!"; break;
                    }
                }
            }
            catch
            {
                result = " ߸!";
            }
            return result;
        }

        public void Recieve()  //Ÿ  óϴ Լ (Thread )
        {
            try
            {
                int recv_bytes = 0;
                Byte[] data = new byte[READ_BUFFER_SIZE];
                String rData = "";
                String inputData = "";
                String st = "";
                int stx_pos, etx_pos;

                while (true)
                {
                    Application.DoEvents();
                    if (_stream.CanRead)
                    {
                        data.Initialize();
                        recv_bytes = _stream.Read(data, 0, READ_BUFFER_SIZE); //Ÿ о
                        if (recv_bytes > 0)
                        {
                            rData = Encoding.Default.GetString(data, 0, recv_bytes);  //ѱ  Encodingó
                            inputData += rData;
                            stx_pos = inputData.IndexOf("\x2");


                            if ((stx_pos >= 0))
                            {
                                st = inputData.Substring(stx_pos + 1, 2);  // Ÿ ޾ ó
                                received(GetStatus(st));  // Receive̺Ʈ 
                                inputData = "";
                            }

                        }
                        else
                        {
                            //  ó...
                            Disconnect();
                            disconnected();
                        }
                    }
                    else
                    {
                        //  ó...
                        Disconnect();
                        disconnected();
                    }

                }

            }
            catch
            {
                return;
            }
        }

        public int WriteTCPASCII(String st)  // Ÿϴ Լ
        {
            try
            {
                if (_connected == true)
                {
                        Encoding oEnc = System.Text.Encoding.GetEncoding(949);
                        byte[] tt = oEnc.GetBytes(st);
                        _stream.Write(tt, 0, tt.Length);
                        _stream.Flush();
                        return st.Length;
                 }
                else return -1;
            }
            catch
            {
                return 0;
            }
        }

        public int WriteTCPUTF8(String st)  // Ÿϴ Լ
        {
            try
            {
                if (_connected == true)
                {
                        Encoding oEnc = System.Text.Encoding.GetEncoding("utf-8");
                        byte[] tt = oEnc.GetBytes(st);
                        _stream.Write(tt, 0, tt.Length);
                        _stream.Flush();
                        return st.Length;
                }
                else return -1;
            }
            catch
            {
                return 0;
            }
        }

        //̹ μ(xġ, yġ, ȸ(0=>0, 90=>1, 180=>2, 270=>3), ̹ȭϸ)
        public void PutImage(int x, int y, int rot, string fname)
        {
            int aHeight;
            int aWidth;
            int i, j, k;
            Byte bb;
            string st;

            if (File.Exists(fname) == false)
            {
                return;
            }
            using (Bitmap bmp = new Bitmap(fname))
            {

                if ((rot == 0) || (rot == 2))
                {
                    aHeight = bmp.Height;
                    aWidth = ((bmp.Width + 7) >> 3) * 8;
                    st = "{" + "SG;" + String.Format("{0:0000}", x) + "," + String.Format("{0:0000}", y) + "," + String.Format("{0:0000}", aWidth) + "," + String.Format("{0:0000}", aHeight) + ",0,";
                    WriteTCPASCII(st);
                }
                else
                {
                    aHeight = ((bmp.Height + 7) >> 3) * 8;
                    aWidth = bmp.Width;
                    st = "{" + "SG;" + String.Format("{0:0000}", x) + "," + String.Format("{0:0000}", y) + "," + String.Format("{0:0000}", aHeight) + "," + String.Format("{0:0000}", aWidth) + ",0,";
                    WriteTCPASCII(st);
                }

                if (rot == 0)
                {
                    j = 0;
                    while (j < aHeight)
                    {
                        i = 0;
                        while (i < aWidth)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i + k) < bmp.Width)
                                {
                                    if (bmp.GetPixel(i + k, j) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            WriteTCPASCII(st);
                            i += 4;
                        }
                        j++;
                    }
                }

                if (rot == 2)
                {
                    j = aHeight - 1;
                    while (j >= 0)
                    {
                        i = aWidth - 1;
                        while (i >= 0)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i - k) < bmp.Width)
                                {
                                    if (bmp.GetPixel(i - k, j) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            WriteTCPASCII(st);
                            i -= 4;
                        }
                        j--;
                    }
                }

                if (rot == 1)
                {
                    j = 0;
                    while (j < aWidth)
                    {
                        i = aHeight - 1;
                        while (i >= 0)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i - k) < bmp.Height)
                                {
                                    if (bmp.GetPixel(j, i - k) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            WriteTCPASCII(st);
                            i -= 4;
                        }
                        j++;
                    }
                }

                if (rot == 3)
                {
                    j = aWidth - 1;
                    while (j >= 0)
                    {
                        i = 0;
                        while (i < aHeight)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i + k) < bmp.Height)
                                {
                                    if (bmp.GetPixel(j, i + k) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            WriteTCPASCII(st);
                            i += 4;
                        }
                        j--;
                    }
                }
                st = "|}";
                WriteTCPASCII(st);
                bmp.Dispose();
            }
        }


        //밡  : B-452
        public string Get452Hangul(string st)
        {
            Encoding oEnc = System.Text.Encoding.GetEncoding(949);
            Byte[] buff = oEnc.GetBytes(st);
            Byte[] oResult = new Byte[2];
            int i, j;

            i = 0;
            j = i;
            while (i <= buff.Length - 1)
            {
                Array.Resize(ref oResult, j + 2);
                if (buff[i] > 128)
                {
                    oResult[j] = buff[i];
                    i = i + 1;
                    oResult[j + 1] = buff[i];
                }
                else
                {
                    oResult[j] = 163;
                    oResult[j + 1] = (byte)(buff[i] + 128);
                }
                i = i + 1;
                j = j + 2;

            }
            return Encoding.Default.GetString(oResult, 0, oResult.Length);
        }

        //밡  : B-482/ B-SA4T ø /B-852/B-SX4T/B-SX5T/EX4T ø
        public string GetHangul(string st)
        {
            Encoding oEnc = System.Text.Encoding.GetEncoding(949);
            Byte[] buff = oEnc.GetBytes(st);
            Byte[] oResult = new Byte[2];
            int i, j;

            i = 0;
            j = i;
            while (i <= buff.Length - 1)
            {
                Array.Resize(ref oResult, j + 2);
                if (buff[i] > 128)
                {
                    oResult[j] = buff[i];
                    i = i + 1;
                    oResult[j + 1] = buff[i];
                }
                else
                {
                    oResult[j] = 201;
                    oResult[j + 1] = (byte)(buff[i] + 129);
                }
                i = i + 1;
                j = j + 2;

            }
            return Encoding.Default.GetString(oResult, 0, oResult.Length);
        }

    }
}
