﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using TBS_USB_DotNet;
using System.IO;

namespace USB_Dll_Sample
{
    public partial class Form1 : Form
    {
        USB_Comm my_usb;

        private const Int32 my_pid = 0xb000;  //Toshiba TEC All = -1, FV4 Series=0xb000, B-EX41/2 Series = 0x0053,  B-EV4D=0x0051, B-SA Series = 0x0034,  B-452-R = 0x004d, B-852-R = 0x003a, B-SX8T = 0x0039, B-SV4D = 0x0007, BA400 시리즈= 0xb002
        private Int32[] printer_pid = new Int32[] { 0x004d, 0x003a, 0xb000, 0x0053, 0x0034, 0x0051, 0x0007, 0x0039, 0xb002, -1 }; //B-452-R,B-852-R,B-FV4 시리즈,B-EX4T1/2 시리즈,B-SA4T 시리즈,B-EV4D,B-SV4D,B-SX8T, BA400시리즈, 도시바TEC 모든프린터

        //Bitmap폰트 한글 변환 함수
        public string GetHangul(string st)
        {
            Encoding oEnc = System.Text.Encoding.GetEncoding(949);
            Byte[] buff = oEnc.GetBytes(st);
            Byte[] oResult = new Byte[2];
            int i, j;

            i = 0;
            j = i;
            while (i <= buff.Length - 1)
            {
                Array.Resize(ref oResult, j + 2);
                if (buff[i] > 128)
                {
                    oResult[j] = buff[i];
                    i = i + 1;
                    oResult[j + 1] = buff[i];
                }
                else
                {
                    oResult[j] = 201;
                    oResult[j + 1] = (byte)(buff[i] + 129);
                }
                i = i + 1;
                j = j + 2;

            }
            return Encoding.Default.GetString(oResult, 0, oResult.Length);
        }

        public Form1()
        {
            InitializeComponent();
            my_usb = new USB_Comm(my_pid); 
            my_usb.RegisterForUsbEvents(Handle);
            my_usb.DeviceArrived += new EventHandler(usb_DeviceArrived);
            my_usb.DeviceRemoved += new EventHandler(usb_DeviceRemoved);
        }

        protected override void WndProc(ref Message m)
        {
            try
            {
                my_usb.ParseMessages(ref m);

                base.WndProc(ref m); // pass message on to base form
            }
            catch (Exception e)
            {

            }
        }

        void usb_DeviceArrived(object sender, EventArgs e)
        {
            
            if(my_usb.GetDevicePath(printer_pid[comboBox1.SelectedIndex]))
            {
                textBox2.Text = "디바이스가 인식되었습니다.";
            }
        }

        void usb_DeviceRemoved(object sender, EventArgs e)
        {
            if (my_usb.IsOnlined() && !my_usb.GetDevicePath(printer_pid[comboBox1.SelectedIndex]))
            {
                textBox2.Text = "디바이스가 제거되었습니다.";
            }
        }


        #region 이미지 인쇄 처리함수
        //이미지 인쇄(x위치, y위치, 회전(0도=>0, 90도=>1, 180도=>2, 270도=>3), 이미지화일명)
        public void PutImage(int x, int y, int rot, string fname)
        {
            int aHeight;
            int aWidth;
            int i, j, k;
            Byte bb;
            string st;
            Boolean chk;

            if (File.Exists(fname) == false)
            {
                return;
            }
            using (Bitmap bmp = new Bitmap(fname))
            {

                if ((rot == 0) || (rot == 2))
                {
                    aHeight = bmp.Height;
                    aWidth = ((bmp.Width + 7) >> 3) * 8;
                    st = "{" + "SG;" + String.Format("{0:0000}", x) + "," + String.Format("{0:0000}", y) + "," + String.Format("{0:0000}", aWidth) + "," + String.Format("{0:0000}", aHeight) + ",0,";
                    chk = my_usb.Send(st);
                }
                else
                {
                    aHeight = ((bmp.Height + 7) >> 3) * 8;
                    aWidth = bmp.Width;
                    st = "{" + "SG;" + String.Format("{0:0000}", x) + "," + String.Format("{0:0000}", y) + "," + String.Format("{0:0000}", aHeight) + "," + String.Format("{0:0000}", aWidth) + ",0,";
                    chk = my_usb.Send(st);
                }

                if (rot == 0)
                {
                    j = 0;
                    while (j < aHeight)
                    {
                        i = 0;
                        while (i < aWidth)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i + k) < bmp.Width)
                                {
                                    if (bmp.GetPixel(i + k, j) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            chk = my_usb.Send(st);
                            i += 4;
                        }
                        j++;
                    }
                }

                if (rot == 2)
                {
                    j = aHeight - 1;
                    while (j >= 0)
                    {
                        i = aWidth - 1;
                        while (i >= 0)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i - k) < bmp.Width)
                                {
                                    if (bmp.GetPixel(i - k, j) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            chk = my_usb.Send(st);
                            i -= 4;
                        }
                        j--;
                    }
                }

                if (rot == 1)
                {
                    j = 0;
                    while (j < aWidth)
                    {
                        i = aHeight - 1;
                        while (i >= 0)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i - k) < bmp.Height)
                                {
                                    if (bmp.GetPixel(j, i - k) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            chk = my_usb.Send(st);
                            i -= 4;
                        }
                        j++;
                    }
                }

                if (rot == 3)
                {
                    j = aWidth - 1;
                    while (j >= 0)
                    {
                        i = 0;
                        while (i < aHeight)
                        {
                            bb = 0;
                            for (k = 0; k < 4; k++)
                            {
                                if ((i + k) < bmp.Height)
                                {
                                    if (bmp.GetPixel(j, i + k) == Color.FromArgb(255, 0, 0, 0))
                                    {
                                        bb = (byte)(bb + (1 << (3 - k)));
                                    }
                                }
                            }
                            bb += 48;
                            st = Convert.ToString((char)(bb));
                            chk = my_usb.Send(st);
                            i += 4;
                        }
                        j--;
                    }
                }
                st = "|}";
                chk = my_usb.Send(st);
                bmp.Dispose();
            }
        }
        #endregion

        private void button3_Click(object sender, EventArgs e)
        {
            Boolean chk;
            chk = my_usb.IsInstalledDriver(textBox3.Text);
            if (chk)
            {
                textBox2.Text = "찾았네요!!";
            }
            else
            {
                textBox2.Text = "못 찾았네요!!";
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Boolean chk = my_usb.Send("\x1b" + "T00C40" + "\x0a\x00");
            Boolean chk = my_usb.Send(textBox1.Text);
            if (!chk)
            {
                textBox2.Text = "USB 디바이스가 연결되지 않았습니다.";
            }
        }

        #region 프린터 상태값 변환 함수
        // 숫자인지 아닌지를 체크하는 함수
        public bool IsNumber(String strNumber)
        {
            Regex objNotNumberPattern = new Regex("[^0-9.-]");
            Regex objTwoDotPattern = new Regex("[0-9]*[.][0-9]*[.][0-9]*");
            Regex objTwoMinusPattern = new Regex("[0-9]*[-][0-9]*[-][0-9]*");
            String strValidRealPattern = "^([-]|[.]|[-.]|[0-9])[0-9]*[.]*[0-9]+$";
            String strValidIntegerPattern = "^([-]|[0-9])[0-9]*$";
            Regex objNumberPattern = new Regex("(" + strValidRealPattern + ")|(" + strValidIntegerPattern + ")");
            return !objNotNumberPattern.IsMatch(strNumber) && !objTwoDotPattern.IsMatch(strNumber) &&
                  !objTwoMinusPattern.IsMatch(strNumber) && objNumberPattern.IsMatch(strNumber);
        }

        private String GetStatus(String data)
        {
            String result = "상태형식 잘못됨!";
            String tt = data.Substring(0, 2);
            try
            {
                if (IsNumber(tt))
                {
                    int stat = int.Parse(tt);
                    switch (stat)
                    {
                        case 0: result = "정상동작!"; break;
                        case 1: result = "헤드열림!"; break;
                        case 2: result = "동작중..."; break;
                        case 3: result = "발행중..."; break;
                        case 4: result = "중지상태"; break;
                        case 6: result = "명령에러"; break;
                        case 7: result = "통신에러"; break;
                        case 11: result = "용지걸림!"; break;
                        case 12: result = "커터에러!"; break;
                        case 13: result = "용지없음!"; break;
                        case 14: result = "리본없음!"; break;
                        case 15: result = "헤드열림!"; break;
                        case 17: result = "헤드에러!"; break;
                        case 18: result = "헤드이상과열!"; break;
                        case 21: result = "리본에러!"; break;
                        case 22: result = "리와인더 오버풀!"; break;
                        case 27: result = "정상동작!"; break;
                        case 28: result = "중지상태"; break;
                        case 29: result = "정상동작!"; break;
                        case 40: result = "발행완료"; break;
                        case 41: result = "피드완료"; break;
                        case 50: result = "플레쉬메모리 다운로드에러"; break;
                        case 51: result = "플레쉬메모리 포맷에러"; break;
                        case 54: result = "플레쉬메로리 용량부족"; break;
                        default: result = "상태알수없음!"; break;
                    }
                }
            }
            catch
            {
                result = "상태형식 잘못됨!";
            }
            return result;
        }
        #endregion

        private void button2_Click(object sender, EventArgs e)
        {
            string r_data = "";
            Boolean chk = my_usb.Send("{WS|}");
            if (!chk)
            {
                textBox2.Text = "USB 디바이스가 연결되지 않았습니다.";
            }
            chk = my_usb.Read(ref r_data);
            //수신흐름 처리
            int stx_pos, etx_pos;
            stx_pos = r_data.IndexOf("\x2");
            etx_pos = r_data.IndexOf("\x3");
            try
            {
                if ((stx_pos >= 0) && (etx_pos >= 0) && (stx_pos < etx_pos))
                {

                    String st = r_data.Substring(stx_pos + 1, etx_pos - stx_pos - 1);  //정상적인 데이타를 받았을때 처리
                    textBox2.Text = GetStatus(st);
                }
            }
            catch
            {
                r_data = "";
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //True Type Font로 한글인쇄
            //주의: 반드시 프린터의 셋팅에서 PC-Code가 UTF-8로 되어있어야 하며, True Type Font가 다운로드 되어있어야 함.
            System.Text.Encoding oEnc = System.Text.UTF8Encoding.GetEncoding("utf-8");
            String send_data;
            send_data = "{D0530,0500,0500|}";
            send_data = send_data + "{C|}";
            Boolean chk = my_usb.Send(oEnc.GetBytes(send_data));
            if (!chk)
            {
                textBox2.Text = "USB 디바이스가 연결되지 않았습니다.";
                return;
            }
            send_data = send_data + "{PV01;0050,0050,0040,0040,01,0,00,B|}";
            send_data = send_data + "{RV01;123ABCabc 가각간(주)티비에스힝|}";
            send_data = send_data + "{PV02;0050,0100,0040,0040,01,0,00,B|}";
            send_data = send_data + "{RV02;123ABCabc *&^%$☆★☎㈜㉿∮㎌|}";
            send_data = send_data + "{XB01;0100,0150,9,3,03,0,0050,+0000000000,000,1,00|}";
            send_data = send_data + "{RB01;ABCD0001|}";
            send_data = send_data + "{XS;I,0001,0000C4001|}";
            chk = my_usb.Send(oEnc.GetBytes(send_data));
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = 0;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //프린터 종류 선택에 대한 pid 지정
            Boolean chk = my_usb.GetDevicePath(printer_pid[comboBox1.SelectedIndex]);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //비트맵폰트로 한글 인쇄
            //한글폰트 다운로드 프로그램으로 다운로드 되어있어야함.
            System.Text.Encoding oEnc = System.Text.UTF8Encoding.GetEncoding(949);
            String send_data;
            send_data = "{D0530,0500,0500|}";
            send_data = send_data + "{C|}";
            Boolean chk = my_usb.Send(oEnc.GetBytes(send_data));
            if (!chk)
            {
                textBox2.Text = "USB 디바이스가 연결되지 않았습니다.";
                return;
            }
            send_data = send_data + "{PC001;0100,0030,1,1,A,00,B|}";
            send_data = send_data + "{RC001;ABCD|}";
            send_data = send_data + "{PC002;0100,0060,1,1,51,00,B|}";
            send_data = send_data + "{RC002;" + GetHangul("가나다123ABC DEF") + "|}";
            send_data = send_data + "{XB01;0100,0100,9,3,03,0,0050,+0000000000,000,1,00|}";
            send_data = send_data + "{RB01;ABCD0001|}";
            send_data = send_data + "{XS;I,0001,0000C4001|}";
            chk = my_usb.Send(oEnc.GetBytes(send_data));
        }
    }
}