﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TBS_Driver_Controller;
using System.Collections;
using System.Drawing.Printing;

namespace Driver_Controller_Sample
{
    public partial class Form1 : Form
    {

        //드라이버명들 가져와서 선택한드라이버명 선택하기
        private void GetDriverNames(String sch_name)
        {
            PrinterSettings settings = new PrinterSettings();
            foreach (string printer in PrinterSettings.InstalledPrinters)
            {
                settings.PrinterName = printer;
                comboBox1.Items.Add(printer);
            }
            int sch_index = comboBox1.Items.IndexOf(sch_name);
            if (sch_index < 0) sch_index = 0;
            comboBox1.SelectedIndex = sch_index;
        }
        //드라이버명들 가져와서 기본프린터선택하기
        private void GetDriverNames()
        {
            PrinterSettings settings = new PrinterSettings();
            string defaultPrinter = "";
            foreach (string printer in PrinterSettings.InstalledPrinters)
            {
                settings.PrinterName = printer;
                comboBox1.Items.Add(printer);
                if (settings.IsDefaultPrinter)
                    defaultPrinter = printer;
            }
            comboBox1.SelectedItem = defaultPrinter;
        }


        //사용가능 프린터 종류: B-482/ B-SA4T 시리즈 /B-852/B-SX4T/B-SX5T
        public string GetHangul(string st)
        {
            Encoding oEnc = System.Text.Encoding.GetEncoding(949);
            Byte[] buff = oEnc.GetBytes(st);
            Byte[] oResult = new Byte[2];
            int i, j;

            i = 0;
            j = i;
            while (i <= buff.Length - 1)
            {
                Array.Resize(ref oResult, j + 2);
                if (buff[i] > 128)
                {
                    oResult[j] = buff[i];
                    i = i + 1;
                    oResult[j + 1] = buff[i];
                }
                else
                {
                    oResult[j] = 201;
                    oResult[j + 1] = (byte)(buff[i] + 129);
                }
                i = i + 1;
                j = j + 2;

            }
            return Encoding.Default.GetString(oResult, 0, oResult.Length);
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if(TBS_Drv_Ctl.PauseDirverJob(comboBox1.Items[comboBox1.SelectedIndex].ToString()))
            {
                MessageBox.Show("일시중지되었음!!");
            }
            else
            {
                MessageBox.Show("일시중지실패!!!");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (TBS_Drv_Ctl.CancelDriverJob(comboBox1.Items[comboBox1.SelectedIndex].ToString()))
            {
                MessageBox.Show("모든문서취소되었음!!");
            }
            else
            {
                MessageBox.Show("모든문서취소실패!!!");
            }

        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (TBS_Drv_Ctl.ResumeDirverJob(comboBox1.Items[comboBox1.SelectedIndex].ToString()))
            {
                MessageBox.Show("재시작되었음!!");
            }
            else
            {
                MessageBox.Show("재시작실패!!!");
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            GetDriverNames();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (TBS_Drv_Ctl.IsDriverOnline(comboBox1.Items[comboBox1.SelectedIndex].ToString()))
            {
                MessageBox.Show("온라인!!");
            }
            else
            {
                MessageBox.Show("오프라인!!!");
            }

        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (TBS_Drv_Ctl.IsInstalledDriver(comboBox1.Items[comboBox1.SelectedIndex].ToString()))
            {
                MessageBox.Show("설치되었음.!!");
            }
            else
            {
                MessageBox.Show("설치안되었음!!!");
            }

        }

        private void button6_Click(object sender, EventArgs e)
        {
            int cnt;
            cnt = TBS_Drv_Ctl.CountDriverJob(comboBox1.Items[comboBox1.SelectedIndex].ToString());
            textBox2.Text = cnt.ToString();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if(TBS_Drv_Ctl.SetDefaultPrinter(comboBox1.Items[comboBox1.SelectedIndex].ToString()))
           {
                MessageBox.Show("디폴트설정되었음!!");
            }
            else
            {
                MessageBox.Show("디폴트설정이안되었음!!!");
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            //ASCII 형식 비트맵 한글 폰트로 인쇄
            ArrayList mList = new ArrayList();
            mList.Add("{D0330,0500,0300|}");
            mList.Add("{C|}");
            mList.Add("{PC001;0030,0030,1,1,A,00,B|}");
            mList.Add("{RC001;ABCDEFG|}");
            mList.Add("{PC002;0030,0070,1,1,51,00,B|}");
            mList.Add("{RC002;" + GetHangul("비트맵한글 TEST 1234") + "|}");
            mList.Add("{XB01;0030,0150,9,3,02,0,0080,+0000000000,000,1,00|}");
            mList.Add("{RB01;CODE128|}");
            mList.Add("{XS;I,0001,0000C5000|}");
            //                RawPrinterHelper.SendStringsToPrinter("TOSHIBA B-FV4 (203 dpi)", "테스트인쇄", mList);
            TBS_Drv_Ctl.SendStringsToPrinter(comboBox1.Items[comboBox1.SelectedIndex].ToString(), "테스트인쇄", mList);
            mList = null;
        }

        private void button9_Click(object sender, EventArgs e)
        {
            //UTF-8 형식 True Type Font로 인쇄
            ArrayList mList = new ArrayList();
            mList.Add("{D0330,0500,0300|}");
            mList.Add("{C|}");
            mList.Add("{PV01;0030,0025,0030,0033,01,0,+000,00,B=가나다라|}");
            mList.Add("{PV02;0030,0067,0030,0033,01,0,+000,00,B=트루타입폰트인쇄|}");
            mList.Add("{PV03;0030,0107,0030,0033,01,0,+000,00,B=(주)티비에스 TEL:032)665-0014|}");
            mList.Add("{XB01;0030,0150,9,3,02,0,0080,+0000000000,000,1,00|}");
            mList.Add("{RB01;CODE128|}");
            mList.Add("{XS;I,0001,0000C5000|}");
            TBS_Drv_Ctl.SendStringsToPrinterUTF8(comboBox1.Items[comboBox1.SelectedIndex].ToString(), "테스트인쇄", mList);
            mList = null;
        }
    }
}
